package wtf.hak.survivalfabric.utils;

import net.minecraft.scoreboard.ServerScoreboard;
import net.minecraft.scoreboard.Team;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;
import net.minecraft.util.Formatting;
import wtf.hak.survivalfabric.commands.SpectatorCommand;

public class DimensionTeams {

    public static DimensionTeams INSTANCE;

    public Team overworldTeam;
    public Team netherTeam;
    public Team endTeam;
    public Team spectatorTeam;
    public Team unknownTeam;

    public DimensionTeams(ServerPlayerEntity player) {
        ServerScoreboard scoreboard = player.getServer().getScoreboard();
        for(Team team : scoreboard.getTeams()) {
            if(team.getName().equals("survivalfabric_overworld")) {
                player.getServer().getPlayerManager().broadcast(Text.literal("found old"), false);
                overworldTeam = team;
            } else if(team.getName().equals("survivalfabric_nether")) {
                player.getServer().getPlayerManager().broadcast(Text.literal("found old"), false);
                netherTeam = team;
            } else if(team.getName().equals("survivalfabric_end")) {
                player.getServer().getPlayerManager().broadcast(Text.literal("found old"), false);
                endTeam = team;
            } else if(team.getName().equals("survivalfabric_spectator")) {
                player.getServer().getPlayerManager().broadcast(Text.literal("found old"), false);
                spectatorTeam = team;
            } else if(team.getName().equals("survivalfabric_unknown")) {
                player.getServer().getPlayerManager().broadcast(Text.literal("found old"), false);
                unknownTeam = team;
            }
        }
        if(overworldTeam == null) {
            overworldTeam = scoreboard.addTeam("survivalfabric_overworld");
            player.getServer().getPlayerManager().broadcast(Text.literal("added new"), false);
        } else if (netherTeam == null) {
            netherTeam = scoreboard.addTeam("survivalfabric_nether");
            player.getServer().getPlayerManager().broadcast(Text.literal("added new"), false);

        } else if (endTeam == null) {
            endTeam = scoreboard.addTeam("survivalfabric_end");
            player.getServer().getPlayerManager().broadcast(Text.literal("added new"), false);

        } else if (spectatorTeam == null) {
            spectatorTeam = scoreboard.addTeam("survivalfabric_spectator");
            player.getServer().getPlayerManager().broadcast(Text.literal("added new"), false);

        } else if (unknownTeam == null) {
            unknownTeam = scoreboard.addTeam("survivalfabric_unknown");
            player.getServer().getPlayerManager().broadcast(Text.literal("added new"), false);

        }

        overworldTeam.setPrefix(Text.literal(Messages.OVERWORLD_PREFIX));
        overworldTeam.setColor(Formatting.GRAY);
        netherTeam.setPrefix(Text.literal(Messages.NETHER_PREFIX));
        netherTeam.setColor(Formatting.GRAY);
        endTeam.setPrefix(Text.literal(Messages.END_PREFIX));
        endTeam.setColor(Formatting.GRAY);
        spectatorTeam.setPrefix(Text.literal(Messages.SPECTATOR_PREFIX));
        spectatorTeam.setColor(Formatting.GRAY);
        unknownTeam.setPrefix(Text.literal(Messages.UNKNOWN_PREFIX));
        unknownTeam.setColor(Formatting.GRAY);
    }

    public static Team assignCorrectTeam(ServerPlayerEntity player, String translationKey) {
        if (INSTANCE == null) {
            INSTANCE = new DimensionTeams(player);
        }

        ServerScoreboard scoreboard = player.getServer().getScoreboard();
        String name = player.getNameForScoreboard();

        for(Team team : player.getServer().getScoreboard().getTeams()) {
            if(team.getName().startsWith("survivalfabric")) {
                if(team.getPlayerList().contains(name))
                    scoreboard.removeScoreHolderFromTeam(name, team);
            }
        }

        if(!SpectatorCommand.spectating.containsKey(player)) {
            switch (translationKey) {
                case "minecraft.overworld":
                    scoreboard.addScoreHolderToTeam(name, INSTANCE.overworldTeam);
                    return INSTANCE.overworldTeam;
                case "minecraft.the_nether":
                    scoreboard.addScoreHolderToTeam(name, INSTANCE.netherTeam);
                    return INSTANCE.netherTeam;
                case "minecraft.the_end":
                    scoreboard.addScoreHolderToTeam(name, INSTANCE.endTeam);
                    return INSTANCE.endTeam;
                default:
                    scoreboard.addScoreHolderToTeam(name, INSTANCE.unknownTeam);
                    return INSTANCE.unknownTeam;
            }
        } else {
            scoreboard.addScoreHolderToTeam(name, INSTANCE.spectatorTeam);
            return INSTANCE.spectatorTeam;
        }
    }
}
